﻿import PICommon_pb2
import remoteapi

"""
TestNotify.py

Unit test for Remote API that runs various Notify functions
"""

client = remoteapi.DiscoveryClient().createClient()

if client is None:
	raise Exception("Failed to connect.")

pi = client.pluginApi()
pi.config().setResponsesEnabled(True)
piCommon = pi.common()

f = piCommon.getNotifyLevel()
if not f.isOk(1000):
  raise Exception("getNotifyLevel failed: " + f.responseDescription())
oldLevel = f.value()

f = piCommon.notify("Changing notify level to WARN.", PICommon_pb2.NOTIFY_ALWAYS, "TestNotify.py")
if not f.isOk(1000):
  raise Exception("notify failed: " + f.responseDescription())

f = piCommon.setNotifyLevel(PICommon_pb2.NOTIFY_WARN)
if not f.isOk(1000):
  raise Exception("setNotifyLevel failed: " + f.responseDescription())

f = piCommon.notify("Printing a message below threshold.", PICommon_pb2.NOTIFY_INFO, "TestNotify.py")
if not f.isOk(1000):
  raise Exception("notify failed: " + f.responseDescription());

f = piCommon.notify("Printing a message without an override category.", PICommon_pb2.NOTIFY_ALWAYS)
if not f.isOk(1000):
  raise Exception("notify failed: " + f.responseDescription());

f = piCommon.notify("Resetting the notify level to what it was.", PICommon_pb2.NOTIFY_ALWAYS, "TestNotify.py")
if not f.isOk(1000):
  raise Exception("notify failed: " + f.responseDescription());

f = piCommon.setNotifyLevel(oldLevel)
if not f.isOk(1000):
  raise Exception("setNotifyLevel failed: " + f.responseDescription());

# Test sending toast notification
f = piCommon.showToastNotification("Test sending toast message from Remote API", PICommon_pb2.TOASTDURATION_SHORT)
if not f.isOk(1000):
	raise Exception("showToastNotification() failed")

client.close()
print("Test successful")
